#ifndef _GC_LIB_H
#define _GC_LIB_H
typedef  unsigned char  UINT8;
typedef  unsigned short UINT16 ;
typedef  unsigned int  UINT32 ;      
typedef  signed char INT8   ;
typedef  short INT16  ;
typedef  int INT32  ;
typedef  unsigned int UINT32;
typedef  signed long  long INT64;
typedef  unsigned long  long UINT64;

#ifdef __cplusplus
extern "C" {
#endif

UINT32 GC_Init(UINT64 addr, UINT64 num);
UINT16 GC_Read_X(UINT16 x_num);
void GC_Write_X(UINT16 x_num, UINT16 vl);
UINT16 GC_Read_Y(UINT16 y_num);
void GC_Write_Y(UINT16 y_num, UINT16 vl);
UINT16 GC_Read_M(UINT16 m_num);
void GC_Write_M(UINT16 m_num, UINT16 vl);
UINT16 GC_Read_SM(UINT16 sm_num);
void GC_Write_SM(UINT16 sm_num, UINT16 vl);
UINT16 GC_Read_S(UINT16 s_num);
void GC_Write_S(UINT16 s_num, UINT16 vl);
UINT16 GC_Read_TT(UINT16 tt_num);
void GC_Write_TT(UINT16 tt_num, UINT16 vl);
UINT16 GC_Read_TV(UINT16 tv_num);
void GC_Write_TV(UINT16 tv_num, UINT16 vl);
UINT16 GC_Read_CT(UINT16 ct_num);
void GC_Write_CT(UINT16 ct_num, UINT16 vl);
UINT16 GC_Read_CV16(UINT16 cv16_num);
void GC_Write_CV16(UINT16 cv16_num, UINT16 vl);
UINT32 GC_Read_CV32(UINT16 cv32_num);
void GC_Write_CV32(UINT16 cv32_num, UINT32 vl);
UINT16 GC_Read_D16(UINT16 d_num);
void GC_Write_D16(UINT16 d_num, UINT16 vl);
UINT32 GC_Read_D32(UINT16 d_num);
void GC_Write_D32(UINT16 d_num, UINT32 vl);
UINT16 GC_Read_SD(UINT16 sd_num);
void GC_Write_SD(UINT16 sd_num, UINT16 vl);
UINT16 GC_Read_R16(UINT16 r_num);
void GC_Write_R16(UINT16 r_num, UINT16 vl);
UINT32 GC_Read_R32(UINT16 d_num);
void GC_Write_R32(UINT16 d_num, UINT32 vl);

UINT16 GC_Read_RD16(UINT16 r_num);
void GC_Write_RD16(UINT16 r_num, UINT16 vl);
UINT32 GC_Read_RD32(UINT16 d_num);
void GC_Write_RD32(UINT16 d_num, UINT32 vl);

UINT16 GC_Read_VD16(UINT16 r_num);
void GC_Write_VD16(UINT16 r_num, UINT16 vl);
UINT32 GC_Read_VD32(UINT16 d_num);
void GC_Write_VD32(UINT16 d_num, UINT32 vl);

UINT16 GC_Read_LW16(UINT16 lw_num);
void GC_Write_LW16(UINT16 lw_num, UINT16 vl);
UINT16 GC_Read_LB(UINT16 lb_num);
void GC_Write_LB(UINT16 lb_num, UINT16 vl);

UINT16 GC_Read_MR16(UINT16 r_num);
void GC_Write_MR16(UINT16 r_num, UINT16 vl);

UINT16 GC_Read_B(UINT16 s_num);
void GC_Write_B(UINT16 s_num, UINT16 vl);
UINT16 GC_Read_L(UINT16 s_num);
void GC_Write_L(UINT16 s_num, UINT16 vl);


UINT16 GC_GetVer();

float GC_SIN(float vl);
float GC_ASIN(float vl);
float GC_COS(float vl);
float GC_ACOS(float vl);
float GC_TAN(float vl);
float GC_ATAN(float vl);
float GC_LOGE(float vl);
float GC_LOG10(float vl);
float GC_EXP(float vl);
float GC_SQR(float vl);

UINT16 GC_Read_UG(UINT32 u, UINT32 g);
void GC_Write_UG(UINT32 u, UINT32 g, UINT16 vl);

#ifdef __cplusplus
}
#endif

#endif